//       


//     
unsigned char gps_parse_string( void ) {

//       
#define GPS_BUFFER_SIZE 8

//          
unsigned char gps_time[ GPS_BUFFER_SIZE ] = { 0 }; 

//      
unsigned char extract_time_buffer[ 3 ] = { 0 };

//   
unsigned char count_comma = 0;  

//  
unsigned char pos = 0;                                 

//         
unsigned char pos_t = 0;  

//     
unsigned long int result = 0;       
                      
                       
//         25 ,    
if ( !rx_buffer_complete || ( strlen( rx_buffer ) < 25 ) ) return 0;

    //            "$GPRMC"
    // $GPRMC,084056.00,A,5430.30076,N,03615.36031,E,0.723,,250517,,,A*7B
    for ( pos_t = 0; pos_t < strlen( rx_buffer ); pos_t++ ) {

    //    "",      ""-   $GPRMC,   
    // ""   ""
    if ( rx_buffer[ pos_t ] == 'M' && rx_buffer[ pos_t + 1 ] == 'C' ) pos = pos_t;  
    }  
    
    //  
    pos_t = 0;

    //      
    while ( pos < strlen( rx_buffer ) ) {
                
        //   
        if ( rx_buffer[ pos ] == ',' ) {
        //    1        
        count_comma++;                                          
        //     ! 1-  ,  
        if ( count_comma == 1 ) pos_t = pos + 1;                
        }
                                                                    
        //   2 ,   
        if ( count_comma >= 2 ) break;                           
        //    1          
        pos++;                                                  
    }    
    
    //    2-  ,    
    if ( count_comma < 2 ) return 0;
    
    //         -   
    if ( rx_buffer[ pos_t ] == ',' ) return 0;

    
    //    X  c  pos_t      
    //    
    pos = 0; 
        
    //      
    while ( pos < GPS_BUFFER_SIZE - 1 ) {  

    //         
    gps_time[ pos ] = rx_buffer[ pos_t + pos ];                 

    //   ""  
    gps_time[ pos + 1 ] = 0;                                     

    //     
    pos++; 
        
    //        -  
    if ( rx_buffer[ pos_t + pos ] == ',' || rx_buffer[ pos_t + pos ] == '.' ) break;            
    }
                      
    //     6-  ,   
    if ( strlen( gps_time ) < 6 ) return 0;
    
    //        0,      
    if ( atol( gps_time ) == 0 ) return 0;         
                           
    //   -     
    //        
    if ( sync_successfull < ( SYNC_SUCCESS - 1 ) ) return 1;
    
    //             
    //     UTC
    utc_counter = 0;
 
    //      2,   3 - 0, 2, 4
    for ( pos = 0; pos < 6; pos += 2 ) {            

    //        gps_time   extract_time_buffer    
    for ( pos_t = 0; pos_t < 2; pos_t++ ) extract_time_buffer[ pos_t ] = gps_time[ pos + pos_t ]; 

    //     
    extract_time_buffer[ 2 ] = 0;

    //          
    result = atoi( extract_time_buffer );   

    //      (..  ),    ""-    3600 
    if ( pos == 0 ) result *= 3600;     

    //     ,    ""-    60 
    if ( pos == 2 ) result *= 60;     

    //    UTC  
    utc_counter += result;
    }
         
    
//   
return 1;
}


//       
void calculation_time( void ) {

//   () 
now_h = utc_counter / 3600;

//   () 
now_m = ( utc_counter % 3600 ) / 60;

//  
now_s = utc_counter % 60;

//   
now_h += utc;

//     24  (),    
if ( now_h >= 24 ) now_h -= 24;

//     0  (  ),    
if ( now_h < 0 ) now_h += 24;
    
}


//    
unsigned char synchronization( void ) {

            //  GPS 
            GPS = GPS_ON;  

            //   
            if ( rx_buffer_complete ) {    

                //     ,     ,  -     
                if ( ( now_h + now_m + now_s ) != 0 ) printf( "%i:%02d:%02d: ", now_h, now_m, now_s ); else printf( "--:--:--: " );                 

                //     
                if ( gps_parse_string() ) {      
                //    GPS    
                gps_status = 1;   
                //      
                sync_successfull++;                                                
                //     
                printf( "SATELLITES SUCCESSFULLY FOUND: " );                                              
                }
                //        
                else {
                //    GPS     
                gps_status = 0;                
                //      
                sync_successfull = 0;  
                //     
                printf( "NO AVAILABLE SATELLITES: " );                                              
                }                                     
                
            //         GPS  
            printf( "%s\r\n", rx_buffer );
                                
            //   
            rx_clear();
            }    
            
            //  SYNC_SUCCESS     
            if ( sync_successfull >= SYNC_SUCCESS ) {                                       
            //  GPS 
            GPS = GPS_OFF;                                   
            //    GPS     
            gps_status = 0;             
            //   
            sync_gps = 0;
            //      
            sync_successfull = 0;       
            //     ,     ,  -     
            if ( ( now_h + now_m + now_s ) != 0 ) printf( "%i:%02d:%02d: ", now_h, now_m, now_s ); else printf( "--:--:--: " );                             
            //       
            printf( "SYNC COMPLETED\r\n" );                                                                          
            }
            //   ,     SYNC_SUCCESS,                         
            else return 0;

//       
return 1;
}


//   
void stopwatch( void ) {

        //        
        stopwatch_counter = 0; 
        
        //       .        
        while( 1 ) {

            //             
            if ( !UTC_BUT || !H_BUT || !M_BUT ) {                                            

            //      
            while( !UTC_BUT || !H_BUT || !M_BUT );

            //   
            delay_ms( 2000 );     

            //    
            return;    
            } 
            
            //    1   
            if ( timer_1s ) {         

            //   
            timer_1s = 0;  

            //       - 
            if ( stopwatch_counter >= ( DAY - 3 ) ) return;  

                //     
                if ( stopwatch_counter < 3600 ) {      

                //      
                now_h = stopwatch_counter / 60;

                //      
                now_m = stopwatch_counter % 60;
                } 
                //     
                else {      
                //       
                now_h = stopwatch_counter / 3600;

                //      
                now_m = ( stopwatch_counter % 3600 ) / 60;                
                }

            //    
            refresh_led_time(); 
             
            //      
            printf( "CURRENT STOPWATCH: %i:%02d:%02d\r\n", stopwatch_counter / 3600, ( stopwatch_counter % 3600 ) / 60, stopwatch_counter % 60 );                
            }


        }    
}