//   

//       
void refresh_utc_led( void ) {

    //     ,     
    signed char tmp_utc = 0;   
    
    //  
    tmp_utc = utc;
    
    //      utc,   
    //    
    if ( utc < 0 ) utc = -utc;

    //   U
    segment[ 0 ] = 17;  
    
    //  ,    -  ,        
    if ( tmp_utc < 0 ) segment[ 1 ] = 10; else segment[ 1 ] = 99;

    //  ,       ,  ,    10 
    if ( utc < 10 ) segment[ 2 ] = utc; else segment[ 2 ] = utc / 10; 

    //  ,   ,    ,    10  
    if ( utc < 10 ) segment[ 3 ] = 99; else segment[ 3 ] = utc % 10; 
    
    //      
    utc = tmp_utc;
}

//      
void utc_but_press( void ) {

//  
unsigned char auto_exit = 0; 

    //         
    if ( !UTC_BUT ) {

    //      ,   
    if ( buzzer_active ) return;

    //   ,      
    main_exe = 0;    

    //    
    dp = L_S_OFF; 

    //  U---
    segment[ 0 ] = 17;   
    segment[ 1 ] = segment[ 2 ] = segment[ 3 ] = 10;   

    //     ""
    delay_ms( 150 );
         
    //     
    while( !UTC_BUT ); 

    //   
    delay_ms( 250 );   

    //    
    refresh_utc_led(); 

        //    
        while( 1 ) {  
         
        //  
        delay_ms( 50 );  

        //   
        auto_exit++;

            //  
            if ( !UTC_BUT ) {  

            //  
            utc++;                

            //   12-  ,    -12 
            if ( utc > 12 ) utc = -12; 

            //    eeprom           
            eeprom_utc = utc;

            //    
            refresh_utc_led(); 

            //   
            auto_exit = 0;

            //     
            while( !UTC_BUT );

            //    
            delay_ms( 200 ); 
            }   

        //   
        if ( auto_exit > 100 ) return;
        } 
    }
}

//      
void refresh_alarm_led( void ) {
   
    //   
    if ( !alarm ) {
    //  
    segment[ 0 ] = segment[ 1 ] = segment[ 2 ] = segment[ 3 ] = 10;
    // 
    return;
    } 
    
    //       (.. >10)    ,       
    if ( ( alarm_h / 10 ) == 0 ) segment[ 0 ] = 99; else segment[ 0 ] = alarm_h / 10;
            
    //   
    segment[ 1 ] = alarm_h % 10; 
            
    //   
    segment[ 2 ] = alarm_m / 10; 
            
    //   
    segment[ 3 ] = alarm_m % 10;       
}

//    
void alarm_but_press( void ) {

//  
unsigned char auto_exit = 0; 

    //          
    if ( !H_BUT ) {   

    //      ,   
    if ( buzzer_active ) return;

    //   ,      
    main_exe = 0;    

    //    
    dp = L_S_ON;     

    //  A-:--
    segment[ 0 ] = 18;   
    segment[ 1 ] = segment[ 2 ] = segment[ 3 ] = 10;    
    
    //     ""
    delay_ms( 150 );

    //     
    while( !H_BUT ); 

    //   
    delay_ms( 250 );   
      
    //    
    refresh_alarm_led(); 

        //    
        while( 1 ) {   

        //    
        delay_ms( 50 );  

        //   
        auto_exit++;  

///////////////////

            //   UTC
            //    UTC
            if ( !UTC_BUT ) {
            //        
            alarm = ~alarm;

            //    
            eeprom_alarm = alarm;  

            //    
            refresh_alarm_led(); 

            //   
            auto_exit = 0;

            //     
            while( !UTC_BUT );

            //    
            delay_ms( 200 );             
            }
            
            //   
            //        
            if ( !H_BUT && alarm ) {                                 

                //        
                while( !H_BUT ) {                                     

                //    +1
                alarm_h++;

                //       
                if ( alarm_h >= 24 ) alarm_h = 0;

                //    
                eeprom_alarm_h = alarm_h;

                //   
                auto_exit = 0;

                //    
                refresh_alarm_led(); 

                //  
                delay_ms( 500 );
                }     
            } 

            //   
            //        
            if ( !M_BUT && alarm ) {                                 

                //        
                while( !M_BUT ) {                                     

                //    +1
                alarm_m++;

                //       
                if ( alarm_m >= 60 ) alarm_m = 0;

                //    
                eeprom_alarm_m = alarm_m;

                //   
                auto_exit = 0;

                //    
                refresh_alarm_led(); 

                //  
                delay_ms( 300 );
                }     
            } 

//////////////////

        //    
        if ( auto_exit > 100 ) return;        
        }

    }

}


//    
void stopwatch_but_press( void ) {

    //        
    unsigned char i = 0;

    //          
    if ( !M_BUT ) {   

    //      ,   
    if ( buzzer_active ) return;

    //   ,      
    main_exe = 0;    

    //    
    dp = L_S_ON;     

    //  C-:--
    segment[ 0 ] = 19;   
    segment[ 1 ] = segment[ 2 ] = segment[ 3 ] = 10;    

    //     ""
    delay_ms( 150 );

    //     
    while( !M_BUT ); 

        //     ,         
        for ( i = 0; i < 4; i++ ) {                                                                    
        //   
        segment[ 1 ] = segment[ 2 ] = segment[ 3 ] = 99;    
        // -   _:__
        delay_ms( 250 );  
        //   
        segment[ 1 ] = segment[ 2 ] = segment[ 3 ] = 10;    
        // -  -:--
        delay_ms( 250 );  
        }
        
        //   
        stopwatch();
    }
    
}   
